package com.blamejared.compat.botania.handlers;

import com.blamejared.compat.botania.lexicon.RemoveRecipeMapping;
import com.blamejared.compat.botania.lexicon.AddRecipeMapping;
import com.blamejared.compat.botania.lexicon.SetCategoryIcon;
import com.blamejared.compat.botania.lexicon.SetCategoryPriority;
import com.blamejared.compat.botania.lexicon.RemoveCategory;
import com.blamejared.compat.botania.lexicon.AddCategory;
import com.blamejared.compat.botania.lexicon.SetEntryKnowledgeType;
import com.blamejared.compat.botania.lexicon.RemoveEntry;
import com.blamejared.compat.botania.lexicon.AddEntry;
import com.blamejared.compat.botania.lexicon.RemovePage;
import com.blamejared.compat.botania.lexicon.pages.AddPageText;
import com.blamejared.compat.botania.lexicon.pages.AddPageRune;
import com.blamejared.compat.botania.lexicon.pages.AddPagePetal;
import com.blamejared.compat.botania.lexicon.pages.AddPageConjuration;
import com.blamejared.compat.botania.lexicon.pages.AddPageAlchemy;
import com.blamejared.compat.botania.lexicon.pages.AddPageInfusion;
import com.blamejared.compat.botania.lexicon.pages.AddPageLore;
import com.blamejared.compat.botania.lexicon.pages.AddPageImage;
import com.blamejared.compat.botania.lexicon.pages.AddPageEntity;
import com.blamejared.compat.botania.lexicon.pages.AddPageElven;
import crafttweaker.api.item.IItemStack;
import com.blamejared.compat.botania.lexicon.pages.AddPageCrafting;
import stanhebben.zenscript.annotations.ZenMethod;
import com.blamejared.compat.botania.lexicon.pages.AddPageBrew;
import com.blamejared.ModTweaker;
import crafttweaker.api.item.IIngredient;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.annotations.ModOnly;
import stanhebben.zenscript.annotations.ZenClass;

@ZenClass("mods.botania.Lexicon")
@ModOnly("botania")
@ZenRegister
public class Lexicon
{
    @ZenMethod
    public static void addBrewPage(final String name, final String entry, final int page_number, final String brew, final IIngredient[] recipe, final String bottomText) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageBrew(name, entry, page_number, brew, recipe, bottomText));
    }
    
    @ZenMethod
    public static void addCraftingPage(final String name, final String entry, final int page_number, final String... recipeNames) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageCrafting(name, entry, page_number, recipeNames));
    }
    
    @ZenMethod
    public static void addElvenPage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[][] inputs) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageElven(name, entry, page_number, outputs, inputs));
    }
    
    @ZenMethod
    public static void addEntityPage(final String name, final String entry, final int page_number, final String entity, final int size) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageEntity(name, entry, page_number, entity, size));
    }
    
    @ZenMethod
    public static void addImagePage(final String name, final String entry, final int page_number, final String resource) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageImage(name, entry, page_number, resource));
    }
    
    @ZenMethod
    public static void addLorePage(final String name, final String entry, final int page_number) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageLore(name, entry, page_number));
    }
    
    @ZenMethod
    public static void addInfusionPage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[] inputs, final int[] mana) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageInfusion(name, entry, page_number, outputs, inputs, mana));
    }
    
    @ZenMethod
    public static void addAlchemyPage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[] inputs, final int[] mana) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageAlchemy(name, entry, page_number, outputs, inputs, mana));
    }
    
    @ZenMethod
    public static void addConjurationPage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[] inputs, final int[] mana) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageConjuration(name, entry, page_number, outputs, inputs, mana));
    }
    
    @ZenMethod
    public static void addPetalPage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[][] inputs) {
        ModTweaker.LATE_ADDITIONS.add(new AddPagePetal(name, entry, page_number, outputs, inputs));
    }
    
    @ZenMethod
    public static void addRunePage(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[][] inputs, final int[] mana) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageRune(name, entry, page_number, outputs, inputs, mana));
    }
    
    @ZenMethod
    public static void addTextPage(final String name, final String entry, final int page_number) {
        ModTweaker.LATE_ADDITIONS.add(new AddPageText(name, entry, page_number));
    }
    
    @ZenMethod
    public static void removePage(final String entry, final int page_number) {
        ModTweaker.LATE_REMOVALS.add(new RemovePage(entry, page_number));
    }
    
    @ZenMethod
    public static void addEntry(final String entry, final String category, final IItemStack stack) {
        ModTweaker.LATE_ADDITIONS.add(new AddEntry(entry, category, stack));
    }
    
    @ZenMethod
    public static void removeEntry(final String entry) {
        ModTweaker.LATE_REMOVALS.add(new RemoveEntry(entry));
    }
    
    @ZenMethod
    public static void setEntryKnowledgeType(final String entry, final String knowledgeType) {
        ModTweaker.LATE_ADDITIONS.add(new SetEntryKnowledgeType(entry, knowledgeType));
    }
    
    @ZenMethod
    public static void addCategory(final String name) {
        ModTweaker.LATE_ADDITIONS.add(new AddCategory(name));
    }
    
    @ZenMethod
    public static void removeCategory(final String name) {
        ModTweaker.LATE_REMOVALS.add(new RemoveCategory(name));
    }
    
    @ZenMethod
    public static void setCategoryPriority(final String name, final int priority) {
        ModTweaker.LATE_ADDITIONS.add(new SetCategoryPriority(name, priority));
    }
    
    @ZenMethod
    public static void setCategoryIcon(final String name, final String icon) {
        ModTweaker.LATE_ADDITIONS.add(new SetCategoryIcon(name, icon));
    }
    
    @ZenMethod
    public static void addRecipeMapping(final IItemStack stack, final String entry, final int page) {
        ModTweaker.LATE_ADDITIONS.add(new AddRecipeMapping(stack, entry, page));
    }
    
    @ZenMethod
    public static void removeRecipeMapping(final IItemStack stack) {
        ModTweaker.LATE_REMOVALS.add(new RemoveRecipeMapping(stack));
    }
}
